#!/usr/bin/env python
#-*- coding:utf-8 -*-

def replace( lst , value , replace ):
    for i,item in enumerate(lst):
        if item == value:
            lst[i] = replace
    return lst

def getRRDxml( xml ):
    """ Function doc

    @param xml: absolute path to XML
    @return xmld: XML dictionary for relevant items
    """
    
    from BeautifulSoup import BeautifulSoup as bs
    
    try:
        f       = open(xml)
        rawXML  = bs(f)
    except IOError:
        print 'File does not exist.'
        return {}
    
    #~ print rawXML.prettify()
    #~ return 1
    
    xmld                = {}
    try:
        xmld['host']    = rawXML.nagios_disp_hostname.string
    except:
        xmld['host']    = []
    try:
        xmld['service'] = rawXML.nagios_disp_servicedesc.string
    except:
        xmld['service'] = []
    try:
        name_list       = rawXML.findAll('name')
        name_list       = map(lambda x: getattr(x,'string'),name_list)
        xmld['title']   = name_list
    except:
        xmld['title']   = []
    try:
        uom_list        = rawXML.findAll('unit')
        uom_list        = map(lambda x: getattr(x,'string'),uom_list)
        xmld['units']   = replace( uom_list , None , '%' )
    except:
        xmld['units']   = []    
    return xmld

def lengthOfPeriod( period_string ):
    """ Function doc

    @param period_string: period_string passed to script of form n,x
    @return RETURN: time in seconds of period
    """
    SECONDS_IN_DAY  = 86400
    SECONDS_IN_WEEK = 604800
    SECONDS_IN_MONTH= 2629743
    SECONDS_IN_YEAR = 31556926
    
    n , t = period_string.split(',')
    n = int(n)
    if t == 'd':
        return n * SECONDS_IN_DAY
    elif t == 'w':
        return n * SECONDS_IN_WEEK
    elif t == 'm':
        return n * SECONDS_IN_MONTH
    elif t == 'y':
        return n * SECONDS_IN_YEAR
    else:
        return 0
        
def getXML( values , metrics , dates ):
    
    from BeautifulSoup import BeautifulSoup as soup, Tag
    import sys
    XML     = soup(selfClosingTags = [ "item" ])
    answers = Tag(XML,"answers")
    XML.insert(0,answers)
    for i,date in enumerate(dates):
        vars()['answer' + str(i)]               = Tag( XML , "answer" )
        vars()['answer' + str(i)]['id']         = date
        answers.insert(i,vars()['answer' + str(i)])
        for j in range(len(values[i])):
            vars()['item' + str(j)]             = Tag( XML , "item" )
            vars()['item' + str(j)]['val']      = values[i][j]
            vars()['item' + str(j)]['units']    = metrics[j].get('units')
            vars()['item' + str(j)]['metric']   = metrics[j].get('title')
            vars()['answer' + str(i)].insert(j,vars()['item' + str(j)])
    return XML.prettify()

def find_nearest(array,value):
    
    import numpy as np
    idx=(np.abs( array - value)).argmin()
    return idx

